<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmClassificacaoDeOportunidadeService;

class CrmClassificacaoDeOportunidadeController
{

    protected $CrmClassificacaoDeOportunidadeService;

    use TResponse;

    public function __construct(CrmClassificacaoDeOportunidadeService $CrmClassificacaoDeOportunidadeService)
    {
        $this->CrmClassificacaoDeOportunidadeService = $CrmClassificacaoDeOportunidadeService;
    }

    public function getClassificationOfOpportunity()
    {
        try {
            $data = $this->CrmClassificacaoDeOportunidadeService->getClassificationOfOpportunityService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveClassificationOfOpportunity(Request $request)
    {
        try {
            $row = $request->getParameters();
            $this->CrmClassificacaoDeOportunidadeService->saveClassificationOfOpportunityService($row);
        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteClassificationOfOpportunity(Request $request)
    {
        try {
            $row = $request->getParameters();
            $this->CrmClassificacaoDeOportunidadeService->deleteClassificationOfOpportunityService($row);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
