<?php

namespace CRM\Service;

use CRM\Factory\CrmFaseDeNegociacaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmFaseDeNegociacaoService
{

    protected $CrmFaseDeNegociacaoFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmFaseDeNegociacaoFactory $CrmFaseDeNegociacaoFactory)
    {
        $this->CrmFaseDeNegociacaoFactory         = $CrmFaseDeNegociacaoFactory;
        $this->Environment                        = $Environment;
        $this->newCode                            = $newCode;
        $this->connection                         = $entityManager->getConnection();
    }

    public function getNegotiationPhaseService()
    {
        return $this->CrmFaseDeNegociacaoFactory->getNegotiationPhaseFactory();
    }

    public function saveNegotiationPhaseService($rows)
    {
        $this->connection->beginTransaction();
        $nrorg = $this->Environment->getNrorg();
        $operador = $this->Environment->getCdOperador();
        $nrorginclusao = 1;
    try {
        foreach ($rows["DRG"] as $row) {
            if ($row["NRSEQFASENEGO"] == 0) {
                
                $cdnrseqfasenego = $this->newCode->getCodeByTableName("CRM_FASENEGOCIO", $nrorg, 1, 5, false);
                
                $params = array(
                    "NRSEQFASENEGO"     => $cdnrseqfasenego,
                    "NMSEQFASENEGO"     => $row["NMSEQFASENEGO"],
                    "IDPERMITEFECHA"    => $row["IDPERMITEFECHA"],
                    "IDEXIGEVROPORT"    => $row["IDEXIGEVROPORT"],
                    "IDEXIBEFUNIL"      => $row["IDEXIBEFUNIL"],
                    "NRORDEM"           => $cdnrseqfasenego,
                    "IDATIVO"           => $row["IDATIVO"],
                    "NRORG"             => $nrorg,
                    "NRORGINCLUSAO"     => $nrorginclusao,
                    "NRORGULTATU"       => $nrorg,
                    "CDOPERINCLUSAO"    => $operador,
                    "CDOPERULTATU"      => $operador,
                );

                $this->CrmFaseDeNegociacaoFactory->insertNegotiationPhaseFactory($params);
            } else {
                $params = array(
                    "NRSEQFASENEGO"     => $row['NRSEQFASENEGO'],
                    "NMSEQFASENEGO"     => $row["NMSEQFASENEGO"],
                    "IDPERMITEFECHA"    => $row["IDPERMITEFECHA"],
                    "IDEXIGEVROPORT"    => $row["IDEXIGEVROPORT"],
                    "IDEXIBEFUNIL"      => $row["IDEXIBEFUNIL"],
                    "NRORDEM"           => $row["NRORDEM"],
                    "IDATIVO"           => $row["IDATIVO"],
                    "NRORG"             => $nrorg,
                    "CDOPERINCLUSAO"    => $operador,
                    "CDOPERULTATU"      => $operador,
                );

                $this->CrmFaseDeNegociacaoFactory->editNegotiationPhaseFactory($params);
            }
        }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
            throw $ex;
        }
    }

    public function deleteNegotiationPhase($rows)
    {
    $this->connection->beginTransaction();
    try {
            $params = implode(',', $rows["NRSQ"]);
            $this->CrmFaseDeNegociacaoFactory->deleteNegotiationPhase($params);
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}